'----------------------------------------------------------
'  PROGRAM: DAYTER.BAS         PROGRAMMER: A. KELLETT
'  DATE-WRITTEN: 06/04/91
'  USING POWER BASIC V2.10A
'
'  THIS PROGRAM CALCULATES THE DAY OF THE WEEK AND DISPLAYS
'  THE DATE, DAY, AND TIME.  GREAT FOR YOUR AUTOEXEC.BAT
'  VERSION: 2.10    LAST UPDATED: 10/15/91
'----------------------------------------------------------
VERSION$ = "2.1"
CUR.DATE$ = DATE$:CUR.TIME$ = TIME$
MONTH = VAL(LEFT$(CUR.DATE$,2))
DAY = VAL(MID$(CUR.DATE$,4,2)):DAY.NUM$ = MID$(CUR.DATE$,4,2)
YEAR = VAL(RIGHT$(CUR.DATE$,2)):YEAR$ = RIGHT$(CUR.DATE$,2)
GOSUB GETMONTH
CALL DAYOFWEEK
HOUR = VAL(LEFT$(CUR.TIME$,2))
MINUTE = VAL(MID$(CUR.TIME$,4,2))
SECOND = VAL(RIGHT$(CUR.TIME$,2))
IF HOUR > 12 THEN
   HOUR = HOUR - 12
   MERIDIAN$ = "pm"
ELSE
   MERIDIAN$ = "am"
END IF
'----- PUT LEADING 0'S (IF NEEDED) ON MINUTES AND SECONDS ----
IF MINUTE < 10 THEN
   MINUTE$ = "0" + RIGHT$(STR$(MINUTE),1)
ELSE
   MINUTE$ = STR$(MINUTE)
   IF LEN(MINUTE$) = 3 THEN
      MINUTE$ = RIGHT$(MINUTE$,2)
   END IF
END IF
IF SECOND < 10 THEN
   SECOND$ = "0" + RIGHT$(STR$(SECOND),1)
ELSE
   SECOND$ = STR$(SECOND)
   IF LEN(SECOND$) = 3 THEN
      SECOND$ = RIGHT$(SECOND$,2)
   END IF
END IF


PRINT "  Today is ";day$;", ";
PRINT MONTH.NAME$;
PRINT USING " \\, 19\\ at ##:\\:\\ \ \  -Dayter v\ \  A.K.";_
   DAY.NUM$,YEAR$,HOUR,MINUTE$,SECOND$,MERIDIAN$,VERSION$
END

'
'  To use: define day,month,year as variables holding 2 digit numbers
'          (check validity first) and expect day$ to return the
'          day-name for that specific date.
'--- This subroutine returns the day-name for a specified date -----
SUB DAYOFWEEK
 shared month,day,year,day$
 local c,j,d$()
 dim d$(7):c = 19 ' c=18 for the 1800's
 d$(0)="SUNDAY":d$(1)="Monday":d$(2)="Tuesday":d$(3)="Wednesday"
 d$(4)="Thursday":d$(5)="Friday":d$(6)="Saturday"
 month = month-2:if month<1 then month=month+12:year =year-1
 j=int(2.6*month-.19)+day+year+int(year/4)+int(c/4)-2*c
 j=j-int(j/7)*7
 day$=d$(j)
END SUB
'
'
'---------------------------------------------------------------
GETMONTH:
   DIM MONTH.TABLE$(12)
      MONTH.TABLE$(1) = "January":MONTH.TABLE$(2) = "February"
      MONTH.TABLE$(3) = "March":MONTH.TABLE$(4) = "April"
      MONTH.TABLE$(5) = "May":MONTH.TABLE$(6) = "June"
      MONTH.TABLE$(7) = "July":MONTH.TABLE$(8) = "August"
      MONTH.TABLE$(9) = "September":MONTH.TABLE$(10) = "October"
      MONTH.TABLE$(11) = "November":MONTH.TABLE$(12) = "December"
   MONTH.NAME$ = MONTH.TABLE$(MONTH)

RETURN

