'----------------------------------------------------------
'  PROGRAM: FASTKYBD.BAS       PROGRAMMER: A. KELLETT
'  DATE-WRITTEN: 09/23/91
'  USING POWER BASIC V2.10A
'
'  THIS PROGRAM CREATES A FILE "KEYFAST.COM" WHICH SETS THE
'  KEYBOARD DELAY TIME AND REPEAT RATE FOR ATs AND PS/2s.
'  VERSION: 0.00    LAST UPDATED: 00/00/00
'----------------------------------------------------------
'***      FOR MORE INFORMATION, SEE  THE PETER NORTON PROGRAMMER'S
'***      GUIDE TO THE IBM PC & PS/2   PP.218-219
'**********************************************************
'            DELAY TIME  ( IN MSEC )   -- DEFAULT IS 500
'     0  250    1  500    2  750    3  1000
'
'               REPEAT RATE ( CHARS/SEC )  -- DEFAULT IS 10 CPS
'  0 30.0     1 26.7     2 24.0     3 21.8     4 20.0     5 18.5
'  6 17.1     7 16.0     8 15.0     9 13.3    10 12.0    11 10.9
' 12 10.0    13  9.2    14  8.6    15  8.0    16  7.5    17  6.7
' 18  6.0    19  5.5    20  5.0    21  4.6    22  4.3    23  4.0
' 24  3.7    25  3.3    26  3.0    27  2.7    28  2.5    29  2.3
' 30  2.1    31  2.0
'
CLS
FILENAME$ = "KEYFAST.COM"
DIM BYTE.ARRAY%(1:16)
DIM REPEAT.ARRAY%(0:31)
KBDELAY% = 0:KBREPEAT% = 0
LOCATE 1,20:PRINT "THIS PROGRAM CREATES A KEYBOARD ENHANCER PROGRAM"
LOCATE 3,5:PRINT "IT ALLOWS YOU TO ENTER THE DELAY TIME & REPEAT RATE YOU"
LOCATE 4,5:PRINT "PREFER AND WRITES A FILE NAMED: ";FILENAME$;" YOU CAN RUN"
LOCATE 5,5:PRINT "FROM THE DOS PROMPT (OR INCLUDE IN A BATCH FILE  IE AUTOEXEC)."
LOCATE 6,5:PRINT "IT WILL NOT WORK AT PC/XT MODELS, ONLY 80286-80486 MACHINES."
LOCATE 9,5:PRINT "PRESS ANY KEY TO CONTINUE, Esc TO EXIT NOW."

FOR I% = 1 TO 16
   READ X
   BYTE.ARRAY%(I%) = X
NEXT I%
FOR I% = 0 TO 31
   READ X
   REPEAT.ARRAY%(I%) = X
NEXT I%

KEYIN$ = ""
DO
   KEYIN$ = UCASE$(INKEY$)
LOOP UNTIL KEYIN$ <> ""
IF KEYIN$ = CHR$(27) THEN
   CLS
   LOCATE 20,5:PRINT "THANKS FOR TRYING FASTKYBD..."
   END
END IF

CLS
LOCATE 5,5:PRINT "PLEASE CHOOSE THE DELAY RATE (HIGHER NUMBER IS SLOWER)"
LOCATE 7,5:PRINT  "0    250 (MILLISECONDS)"
LOCATE 8,5:PRINT  "1    500"
LOCATE 9,5:PRINT  "2    750"
LOCATE 10,5:PRINT "3   1000"
LOCATE 12,5:PRINT "   default rate for ATs & PS/2s is 500ms"

KEYIN$ = ""
DO
   KEYIN$ = UCASE$(INKEY$)
LOOP UNTIL INSTR(" 0123", KEYIN$) > 1
KBDELAY% = VAL(KEYIN$)
BYTE.ARRAY%(5) = KBDELAY%
CLS
PRINT "                KEYBOARD REPEAT RATE  --  CHARACTERS PER SECOND"
LOCATE 4,1
PRINT "           0  30.0       A  12.0       K   5.0       U   2.1  "
PRINT "           1  26.7       B  10.9 <-a   L   4.6       V   2.0  "
PRINT "           2  24.0       C  10.0 <-b   M   4.3                "
PRINT "           3  21.8       D   9.2       N   4.0                "
PRINT "           4  20.0       E   8.6       O   3.7                "
PRINT "           5  18.5       F   8.0       P   3.3                "
PRINT "           6  17.1       G   7.5       Q   3.0                "
PRINT "           7  16.0       H   6.7       R   2.7                "
PRINT "           8  15.0       I   6.0       S   2.5                "
PRINT "           9  13.3       J   5.5       T   2.3                "
PRINT
PRINT "           a  default for PS/2s      b  default for ATs"

PRINT:PRINT "           PLEASE CHOOSE THE REPEAT RATE (CHARACTERS PER SEC.)"

KEYIN$ = ""
DO
   KEYIN$ = UCASE$(INKEY$)
LOOP UNTIL INSTR(" 0123456789ABCDEFGHIJKLMNOPQRSTUV", KEYIN$) > 1
IF ASC(KEYIN$) < 65 THEN
   KBREPEAT% = ASC(KEYIN$) - 48
ELSE
   KBREPEAT% = ASC(KEYIN$) - 55
END IF
BYTE.ARRAY%(7) = KBREPEAT%
LOCATE 19,1
GOSUB WRITEBYTES

END
'
' THIS MODULE WRITES THE BYTES TO A SPECIFIED .COM FILE
'----------------------------------------------------------
WRITEBYTES:

   OPEN FILENAME$ FOR BINARY AS #1
      IF EOF(1) > 0 THEN
         CLOSE #1
         KILL FILENAME$
         OPEN FILENAME$ FOR BINARY AS #1
      END IF

      FOR I% = 1 TO 16
         PUT$ 1, CHR$(BYTE.ARRAY%(I%))
      NEXT I%
   CLOSE #1
   PRINT "        FILE: ";FILENAME$;" - WRITTEN TO DISK."
   PRINT

RETURN
'
'
'--------------------------------------
DATA 184, 05, 03, 183, 00
DATA 179, 00, 205, 22
REM*NEXT LINE*** MOV AH,4C    MOV AL,[0110]    INT 21  ***
DATA 180, 76, 160, 16, 01, 205, 33
'
'
DATA 30.0, 26.7, 24.0, 31.8, 20.0, 18.5
DATA 17.1, 16.0, 15.0, 13.3, 12.0, 10.9
DATA 10.0, 9.2, 8.6, 8.0, 7.5, 6.7
DATA 6.0, 5.5, 5.0, 4.6, 4.3, 4.0
DATA 3.7, 3.3, 3.0, 2.7, 2.5, 2.3
DATA 2.1, 2.0
'
'
'
'  MOV  AX, 0305h
'  MOV  BH, KBDELAY
'  MOV  BL, KBREPEAT
'  INT  16h
'  INT  21h
'
'
