'----------------------------------------------------------
'  PROGRAM: PBTOGGLE.BAS         PROGRAMMER: A. KELLETT
'  DATE-WRITTEN: 11/11/91
'  USING POWER BASIC V2.10A
'
'  THIS PROGRAM SETS THE STATUS OF THE CAPS LOCK, NUM LOCK,
'  AND SCROLL LOCK KEYS...
'  VERSION: 0.00    LAST UPDATED: 00/00/00
'----------------------------------------------------------
$INCLUDE "KEYS.INC"
KY$ = UCASE$(COMMAND$)
IF (KY$ = "" OR (LEN(KY$) > 3)) THEN
   PRINT "usage is PBTOGGLE [XXX] where x is any one or more of  C or S or N"
   PRINT "  purpose: <<change>> status of Caps Lock or Num Lock or Scroll Lock"
   END
END IF
NUMPARAMS% = LEN(KY$)

DEF SEG = &H0040
STATUSBYTE% = &H0017

FOR I% = 1 TO NUMPARAMS%
   BYTEVALUE% = PEEK(STATUSBYTE%)
   XKY$ = MID$(KY$,I%,1)
   IF XKY$ = "C" THEN
      NEWBYTEVALUE% = BYTEVALUE% XOR 64
      POKE STATUSBYTE%, NEWBYTEVALUE%
   ELSE
      IF XKY$ = "N" THEN
         NEWBYTEVALUE% = BYTEVALUE% XOR 32
         POKE STATUSBYTE%, NEWBYTEVALUE%
      ELSE
         IF XKY$ = "S" THEN
            NEWBYTEVALUE% = BYTEVALUE% XOR 16
            POKE STATUSBYTE%, NEWBYTEVALUE%
         ELSE
            PRINT USING "INVALID PARAMETER NUMBER #.";I%
         END IF
      END IF
   END IF

NEXT I%

END
