'----------------------------------------------------------
'  PROGRAM: DAYSTWEN.BAS       PROGRAMMER: A. KELLETT
'  DATE-WRITTEN: 07/30/91
'  USING POWER BASIC V2.10A
'
'  THIS PROGRAM CALCULATES THE NUMBER OF DAYS BETWEEN TWO
'  SPECIFIED DATES.
'  VERSION: 0.00    LAST UPDATED: 00/00/00
'----------------------------------------------------------
CLS
DAY = 5:MONTH = 05:YEAR = 90
DAY1 = 4:MONTH1 = 05:YEAR1 = 91
PRINT USING "FIRST DATE  :  DAY ##   MONTH ##   YEAR ##";DAY,MONTH,YEAR
PRINT USING "SECOND DATE :  DAY ##   MONTH ##    YEAR ##";DAY1,MONTH1,YEAR1
CALL DAYSTWIXTDATES
PRINT USING "THERE WERE ### DAYS BETWEEN THE TWO DATES.";DAYSBETWEEN

END
'
' To use: define day,month,year as 2 digit variables holding the first date
'         and day1,month1,year1 as 2 digit variables holding the second date
'         and expect daysbetween to hold the number of days between the
'         the two dates
'--- This subroutine calculates the days between two given (valid) dates ----
SUB DAYSTWIXTDATES
 shared month,day,year,month1,day1,year1,daysbetween
 local dx,de,dy,d(),j:dim d(12)
 d(1)=0:d(2)=31:d(3)=59:d(4)=90:d(5)=120:d(6)=151:d(7)=181:d(8)=212:d(9)=243:_
    d(10)=273:d(11)=304:d(12)=334
 de=day+d(month)+365*year+int((year-1)/4)-((int(year/4)*4=year)and(month>2))
 dy=day1+d(month1)+365*year1+int((year1-1)/4)-((int(year1/4)*4=year1)_
     and(month1>2))
 daysbetween = dy-de
END SUB
