'   FILENAME: GETCHAR.INC      PROGRAMMER: ANDY KELLETT
'   ALLOWS PROTECTED ENTRY OF SPECIFIED CHARACTERS
'   X% - LINE TO BEGIN ENTRY, Y% - COLUMN TO BEGIN ENTRY
'   LENGTH% - NUMBER OF CHARACTERS WHICH MAY BE ENTERED
'   SET$ - CHARACTERS WHICH ARE VALID TO BE ENTERED
'   INSTRING$ - HOLDS ENTERED CHARACTERS TO BE RETURNED
'
'    USE   $INCLUDE "GETCHAR.INC"   IN YOUR SOURCE CODE
' *->YOU SHOULD ALSO USE       $INCLUDE "CHARS.INC" TO
'    PROPERLY DEFINE CR$ AND DEL$  !!!
'----------------------------------------------------------
SUB GETCHAR(X%,Y%,LENGTH%,SET$)
   SHARED CR$, DEL$, INSTRING$
   LOCAL QUITFLAG%, CHAR$, L%, M%
   QUITFLAG% = 0
   LOCATE X%,Y%
   INSTRING$ = ""
   WHILE QUITFLAG% = 0
      '*** IF <RETURN> OR LENGTH IS LONG ENOUGH - EXIT ROUTINE ***
      IF (LENGTH% <= LEN(INSTRING$)) OR (CHAR$ = CR$) THEN
         QUITFLAG% = 1
      ELSE
         CHAR$ = "":M% = 0
         '*** LOOP UNTIL A VALID CHARACTER IS ENTERED ***
         WHILE M% = 0
            CHAR$ = INKEY$
            IF CHAR$ <> "" THEN
               M% = INSTR(1,(SET$+CR$),CHAR$)
            END IF
         WEND
         '*** NOT RETURN, THEN TEST FOR DELETE CHARACTER ***
         IF CHAR$ <> CR$ THEN
            '*** MUST BE A VALID CHARACTER, ADD TO INSTRING$ ***
            IF CHAR$ <> DEL$ THEN
               '*** why make uppercase? ***CHAR$ = UCASE$(CHAR$)
               INSTRING$ = INSTRING$ + CHAR$
               Y% = Y% + 1
               LOCATE X%,Y%:PRINT CHAR$;
            ELSE
               '*** IF VALID DELETE, DELETE RIGHTMOST CHARACTER ***
               IF (CHAR$ = DEL$) AND (LEN(INSTRING$) > 0) THEN
                  L% = LEN(INSTRING$)
                  INSTRING$ = LEFT$(INSTRING$,L% - 1)
                  LOCATE X%,Y%:PRINT " ";
                  Y% = Y% - 1
               END IF
            END IF
         END IF
      END IF
   WEND
END SUB

