'----------------------------------------------------------
'  PROGRAM: GETDRIVE.BAS       PROGRAMMER: A. KELLETT
'  DATE-WRITTEN: 10/18/91
'  USING POWER BASIC V2.10A
'
'  THIS PROGRAM GETS THE CURRENT DRIVE
'
'  VERSION: 0.00    LAST UPDATED: 00/00/00
'----------------------------------------------------------
CLS
CALL GETDRIVE(DRIVE%)
PRINT "THE CURRENT DISK DRIVE IS: ";CHR$(DRIVE% + 65)

END
'
' RETURNS DRIVE AS A NUMBER - A=0, B=1, C=2, ETC
' CONVERT TO LETTER BY:   DRIVELETTER$ = CHR$(DRIVEX% + 65)
'----------------------------------------------------------
SUB GETDRIVE (DRIVEX%)
   %FL = 0: %AX = 1: %BX = 2: %CX = 3: %DX = 4
   %SI = 5: %DI = 6: %BP = 7: %DS = 8: %ES = 9

   REG %AX, &H1900                ' SET AH FOR GET DRIVE SERVICE
   CALL INTERRUPT &H21            ' ASK DOS FOR CURRENT DRIVE

   DRIVEX% = REG(%AX) AND &HFF     ' DRIVE # IS IN AX, - CLEAR HIGH PART (AH)

END SUB
