'   PROGRAM:  JULIAN.BAS               PROGRAMMER:  ANDY KELLETT
'   DATE-WRITTEN: 07/08/91             USING TURBO BASIC V1.1
'
'   THIS PROGRAM ALLOWS THE USER TO TO ENTER A DATE AND RETURNS
'   A JULIANIZED DATE.
'
'   LAST-UPDATED: 00/00/00  00:00 PM
'--------------------------------------------------------------------
CLS
GOSUB INITIALIZE
GOSUB ISLEAPYEAR
ISLEAP = 0
JULIAN.DAY% = MONTH.TABLE%(MONTH.NUM%)
IF (ISLEAP > 1 AND MONTH.NUM% > 1) THEN
   JULIAN.DAY% = JULIAN.DAY% + 1
END IF
JULIAN.DAY% = JULIAN.DAY% + DAY.NUM%
PRINT "THE YEAR IS : ";YEAR.NUM%
PRINT "THE DAY IS  : ";JULIAN.DAY%

PRINT "THE DATE IS : ";DATE$
PRINT "MONTH NUM   : ";MONTH.NUM%
PRINT "YEAR NUM    : ";YEAR.NUM%
PRINT "DAY NUM     : ";DAY.NUM%

END

'---
INITIALIZE:
   DIM MONTH.TABLE%(12)
   MONTH.TABLE%(1)  = 31
   MONTH.TABLE%(2)  = 59
   MONTH.TABLE%(3)  = 90
   MONTH.TABLE%(4)  = 120
   MONTH.TABLE%(5)  = 151
   MONTH.TABLE%(6)  = 181
   MONTH.TABLE%(7)  = 212
   MONTH.TABLE%(8)  = 243
   MONTH.TABLE%(9)  = 273
   MONTH.TABLE%(10) = 304
   MONTH.TABLE%(11) = 334
   MONTH.TABLE%(12) = 365

   MONTH.NUM% = VAL(LEFT$(DATE$,2))
   DAY.NUM% = VAL(MID$(DATE$,4,2))
   YEAR.NUM% = VAL(RIGHT$(DATE$,2))
   IF MONTH.NUM% > 1 THEN
      MONTH.NUM% = MONTH.NUM% - 1
   END IF

RETURN
'
'
'----
ISLEAPYEAR:
   ISLEAP = 0
   YEAR = YEAR.NUM% + 1900 : REM *** USE 1800, 1700, ETC. AS NECESSARY

   IF YEAR/4 = INT(YEAR/4) THEN
      ISLEAP = 1
      IF YEAR/100 = INT(YEAR/100) THEN
         ISLEAP = 0
         IF YEAR/400 = INT(YEAR/400) THEN
            ISLEAP = 1
         END IF
      END IF
   END IF

RETURN
