'   FILENAME: NUMBERS.INC      PROGRAMMER: ANDY KELLETT
'   DATE WRITTEN: 05/07/91
'   FOR MORE DETAILS, SEE THE POWERBASIC USER'S GUIDE P.107, PP.205-215
'   THIS FILE MERELY DOCUMENTS THE TYPES OF NUMERIC VARIABLES AVAILABLE
'   USING THE TURBO AND POWERBASIC COMPILERS.  EACH TYPE OF NUMERIC
'   VARIABLE IS MARKED T, P, OR BOTH FOR WHICH COMPILER IT IS AVAILABLE IN.
'--------------------------------------------------------------------------
' TP  X%    16 BIT INTEGERS           -32,768 to 32,767
' TP  X&    32 BIT LONG INTEGERS      -2,147,483,648 to 2,147,483,647
'  P  X&&   64 BIT QUAD INTEGERS      -+9.22x10^18 to +-9.22x10^18
'                        (FLOATING POINT)
' TP  X!    32 BIT SINGLE PRECISION   -+8.43x10^-37 to +-3.37x10^38
'
' TP  X#    64 BIT DOUBLE PRECISION   -+4.19x10^-307 to +-1.67x10^308
'  P  X##   80 BIT EXTENDED PRECISION -+3.4X10^-4932 to +-1.2x10^4932
'
'  P  X@    64 BIT BINARY CODED DECIMAL FIXED POINT
'             (18 DIGITS OF PRECISION)         -+9.99x10^-63 to +-9.99x10^63
'             FIXDIGITS DETERMINES DIGITS RIGHT OF DECIMAL ( 0 - 18 )
'
'  P  X@@   80 BIT BINARY CODED DECIMAL FLOATING POINT
'             (  "           "     )           -+9.99x10^-63 to +-9.99x10^63
'             SAME RANGE AS EXTENDED PRECISION
'
