'     program: stripper.bas     programmer: Andy Kellett 02/11/91
'     using Power Basic v2.00
'     This program strips specified characters from a file and writes
'     a new file to disk.
'
'     Last Updated: 11/01/91
'--------------------------------------------------------------------
$INCLUDE "CHARS.INC"
CLS
locate 1,25:print "STRIPPER  -  A. KELLETT"
LOCATE 2,15:PRINT "THIS PROGRAM STRIPS SPECIFIED CHARACTERS FROM A FILE."
LOCATE 4,5:INPUT "NAME OF INPUT FILE: ";FILENAME1$

'*** CHECK VALIDITY OF INPUT FILE NAME ***
OPEN FILENAME1$ FOR BINARY AS #1
   IF LOF(1) < 1 THEN
      PRINT "THE INPUT FILE DOES NOT EXISTS."
      CLOSE #1
      KILL FILENAME1$
      DELAY 2.5
      LOCATE 22,1
      END
   END IF
CLOSE #1
LOCATE 5,5:INPUT "NAME OF OUTPUT FILE: ";FILENAME2$
'*** CHECK VALIDITY OF OUTPUT FILE NAME ***
OPEN FILENAME2$ FOR BINARY AS #2
   IF LOF(2) > 1 THEN
      PRINT "THE OUTPUT FILE ALREADY EXISTS."
      CLOSE #2
      KILL FILENAME2$
      DELAY 2.5
      LOCATE 22,1
      END
   END IF
CLOSE #2
DO
   LOCATE 6,5:PRINT "ENTER (C)HARACTER TO STRIP OR (A)SCII VALUE: ";
   INPUT TYPECHAR$
   TYPECHAR$ = UCASE$(TYPECHAR$)
LOOP UNTIL (TYPECHAR$ = "C") OR (TYPECHAR$ = "A")
IF TYPECHAR$ = "C" THEN
   INSTRING$ = ""
   LOCATE 7,5:PRINT "ENTER CHARACTER: "
   CALL GETCHAR(7,23,1,NORMAL$)
   DELETECHAR$ = INSTRING$
ELSE
   INSTRING$ = ""
   LOCATE 7,5:PRINT "ENTER VALUE (0 - 255)"
   CALL GETCHAR(7,28,3,NUMBER$)
   IF VAL(INSTRING$) > 255 THEN
      LOCATE 10,5:PRINT "ASCII VALUE CANNOT BE OVER 255!"
      END
   END IF
   DELETENUM = VAL(INSTRING$)
   DELETECHAR$ = CHR$(DELETENUM)
END IF

LOCATE 14,5:PRINT "WORKING ON BYTE: "
OPEN FILENAME1$ FOR BINARY AS #1
OPEN FILENAME2$ FOR BINARY AS #2
   FILE1EOF& = LOF(1)
   LOCATE 13,5:PRINT USING "SIZE OF FILE: ##,###,###";FILE1EOF&
   FOR RECPOSITION& = 0 TO FILE1EOF&
      SEEK 1, RECPOSITION&
      GET$ 1, 1, CHAR$
      IF CHAR$ <> DELETECHAR$ THEN
         PUT$ 2, CHAR$
      END IF
      LOCATE 14, 22:PRINT USING "###,###";RECPOSITION&
   NEXT RECPOSITION&
CLOSE #2:CLOSE #1
LOCATE 16,10:PRINT "PROGRAM COMPLETED"
END

$INCLUDE "GETCHAR.INC"

