'----------------------------------------------------------
'  PROGRAM: UPPER.BAS          PROGRAMMER: A. KELLETT
'  DATE-WRITTEN: 11/11/91
'  USING POWER BASIC V2.10A
'
'  THIS PROGRAM CONVERTS A FILE TO ALL UPPERCASE
'  ALPHABETIC CHARACTERS
'  VERSION: 0.00    LAST UPDATED: 00/00/00
'----------------------------------------------------------
CLS
LOCATE 1,20:PRINT "CONVERT A FILE TO ALL UPPERCASE."
LOCATE 5,5:INPUT "NAME OF INPUT FILE : ";FILENAME1$
LOCATE 7,5:INPUT "NAME OF OUTPUT FILE: ";FILENAME2$

GOSUB FILESEXIST

IF FILE1EOF& < 32000 THEN
   BUF.LEN& = FILE1EOF&
ELSE
   BUF.LEN& = 32000
END IF
BYTES.READ& = 0:BYTES.LEFT& = FILE1EOF&
QUITFLAG% = 0

OPEN FILENAME1$ FOR BINARY AS #1
OPEN FILENAME2$ FOR BINARY AS #2
WHILE QUITFLAG% = 0
   LOCATE 10,5:PRINT USING "BYTES FINISHED: #,###,###  BYTES LEFT: #,###,###";_
      BYTES.READ&, BYTES.LEFT&
   GET$ 1, BUF.LEN&, IN.BUFFER$
   GOSUB CONVERT
   PUT$ 2, OUT.BUFFER$
   BYTES.READ& = BYTES.READ& + BUF.LEN&
   BYTES.LEFT& = BYTES.LEFT& - BUF.LEN&
   IF BYTES.LEFT& < 1 THEN
      QUITFLAG% = 1
   ELSE
      IF BYTES.LEFT& < BUF.LEN& THEN
	 BUF.LEN& = BYTES.LEFT&
      END IF
   END IF
WEND
CLOSE #2
CLOSE #1

END
'
' PERFORM ACTUAL BYTE CONVERSION HERE...
'----------------------------------------------------------
CONVERT:
   OUT.BUFFER$ = UCASE$(IN.BUFFER$)

RETURN
'
'
'----------------------------------------------------------
FILESEXIST:
   '*** CHECK VALIDITY OF INPUT FILE NAME ***
   OPEN FILENAME1$ FOR BINARY AS #1
      IF LOF(1) < 1 THEN
         PRINT "THE INPUT FILE DOES NOT EXISTS."
         CLOSE #1
         KILL FILENAME1$
         DELAY 2.5
         LOCATE 22,1
         END
      END IF
      FILE1EOF& = LOF(1)
   CLOSE #1

   '*** CHECK VALIDITY OF OUTPUT FILE NAME ***
   OPEN FILENAME2$ FOR BINARY AS #2
      IF LOF(2) > 1 THEN
         PRINT "THE OUTPUT FILE ALREADY EXISTS."
         CLOSE #2
         KILL FILENAME2$
         DELAY 2.5
         LOCATE 22,1
         END
      END IF
      FILE2EOF& = LOF(2)
   CLOSE #2

RETURN


