'----------------------------------------------------------
'  PROGRAM: VALIDATE.BAS       PROGRAMMER: A. KELLETT
'  DATE-WRITTEN: 07/30/91
'  USING POWER BASIC V2.10A
'
'  THIS PROGRAM CHECKS THE VALIDITY OF A GIVEN DATE.
'
'  VERSION: 0.00    LAST UPDATED: 00/00/00
'----------------------------------------------------------
CLS:LOCATE 1,25:PRINT "DATE VALIDATION TEST PROGRAM"
LOCATE 3,5:INPUT "ENTER THE MONTH NUMBER [1-12] :";MONTH
LOCATE 4,5:INPUT "ENTER THE DAY NUMBER [1-31]   :";DAY
LOCATE 5,5:INPUT "ENTER THE YEAR [1-99]         :";YEAR
CALL DATEVALIDATOR
PRINT "THAT DATE IS : ";RESPONSE$

END
'
'
'  To use: define day,month,year as variables holding 2 digit numbers
'          and expect Response$ to be "good" or "nogood".
'--- This subroutine checks date validity for the 20th century(1900's) ----
SUB DATEVALIDATOR
 shared day,month,year,response$
 local ok
 response$ = ""
 ok = month>0 and month<13 and day>0 and year>87 and year<99
 ok = ok and day<32 +(month=4 or month=6 or month=9 or month=11)_
      +(month=2)*(3+(int(year/4)*4=year))
 if ok then response$ ="GOOD":else response$ ="NOGOOD"
END SUB

